<?php
    class CnxPg {
        private $host;
        private $port;
        private $dbname;
        private $user;
        private $password;
        private $login;
        private $cnx;

        function __construct($host, $port, $dbname, $user, $password, $login = null) {
            $this->host = $host;
            $this->port = $port;
            $this->dbname = $dbname;
            $this->user = $user;
            $this->password = $password;
            $this->login = $login;
            $this->cnx = pg_connect($this->paramCnx());
            if (!$this->cnx) {
                $errorMessage = 'ATTENTION : connexion impossible !!!';
                $data = 'Paramètres : ' . $this->paramCnx();
                unset($this);
                die('{success: false, errorMessage: "' . $errorMessage . '", data: "' .
                    $data .'"}');
            }
        }

        function  __destruct() {
            pg_close($this->cnx);
        }

        function paramCnx() {
            return 'host=' . $this->host . ' port=' . $this->port . ' dbname=' .
                $this->dbname . ' user=' . $this->user . ' password=' . $this->password;
        }

        function executeSql($req) {
            // excution de la requte avec passage du login de connexion  la session PostGres
            if (isset($this->login)) {
                $rs = @pg_query($this->cnx, "SELECT outils.set_user('" . $this->login .
                    "');" . $req); // pg_query <=> pg_prepare/pg_execute
            }
            else {
                $rs = @pg_query($this->cnx, $req);
            }
            if ($rs) {
                return $rs;
            }
            else {
                $errorMessage = str_replace(CHR(10), ' ', pg_errormessage()); // suppression des retours  la ligne
                $errorMessage = addslashes($errorMessage); // ajout des antislashs aux guillemets simples, doubles, antislash et le caractre NULL
                $data = 'SQL : ' . $req;
                $data = str_replace(CHR(10), ' ', $data); // suppression des retours  la ligne
                die('{success: false, errorMessage: "' . $errorMessage . '", data: "' .
                    $data .'"}');
            }
        }
    }
?>
